#include <filesystem>
#include <iostream>
#include <fstream>
#include "graph.hpp"
#include "utils.hpp"

using namespace std;

int main(int argc, char *argv[]) {
	if(argc <= 2)
		return 0;
	graph<unsigned, unsigned> G(argv[1]);
	cout << G.N << ' ' << G.xadj[G.N] << endl;
	auto hist = shellSeqToHist(G.shellSeq1());
	auto filename = filesystem::path(argv[1]).stem().string() + "-hist.txt";
	ofstream out(filesystem::path(argv[2]) / filename);
	for(size_t i = 0; i < hist.size(); i++)
		out << (i > 0 ? " " : "") << hist[i];
	return 0;
}