#ifndef _MPI_GENERATOR_H
#define _MPI_GENERATOR_H
#include <vector>
#include <mpi.h>
#include <random>
#include <cstdint>
#include "io.hpp"
#include "graph.hpp"


#define NO_COMM_GUARANTEED -1

#define COMM_ALL2ALL_BELOW 7

#define COMM_POINT_TO_POINT_ABOVE 15

#define COMM_ALL2ALL 0
#define COMM_ALL2ALL_SPLIT 8

#define COMM_ONE2ONE 16
#define COMM_ONE2ONE_BETTER 17

graph <uint64_t, sizeType> generateGraphWithShellSequence(std::vector<int>& begin, const uint64_t size, const uint64_t n, std::vector<uint64_t>& hist_starti, std::vector<uint64_t>& all_start_indices, const int comm_mode, const int randomSeed, timeType* times);

#endif